package model

type MealLabel struct {
	Id           int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	Name         string `json:"name" xorm:"not null default '' comment('名称') VARCHAR(255)"`
	EnterpriseId int    `json:"enterprise_id" xorm:"not null default 0 comment('单位id') INT(11)"`
	GradeId      int    `json:"grade_id" xorm:"not null default 0 comment('年级id') INT(11)"`
	Kind         int32  `json:"kind" xorm:"not null default 0 comment('餐标类型(1:早餐 2:午餐 3:晚餐)') INT(11)"`
	Price        string `json:"price" xorm:"not null default 0.00 comment('单价') DECIMAL(4,2)"`
	CreateAt     string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt     string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
